
//This file simply prints out most of the WSDL elements encountered
//demonstrates the WSDL pull API
#include <iostream>
#include <fstream>
#include <string>
#include <xmlpull/XmlPullParser.h>
#include <xmlpull/XmlPullParserException.h>
#include <schemaparser/SchemaParser.h>
#include <schemaparser/SchemaParserException.h>
#include <wsdlparser/WsdlParser.h>
#include <wsdlparser/SoapExt.h>
  using namespace std;
int 
main (int argc, char *argv[]) 
{
  ifstream ifs;
  ofstream ofs;
  if (argc <= 1)
    
    {
      cout << "Usage: print <wsdl_File_Name>" << endl;
      return 1;
    }
  
  else
    
    {
      ifs.open (argv[1]);
      if (ifs.fail ())
        
        {
          cout << "An Error occrred while opening " << argv[1] << endl;
          return 1;
        }
    }

 try{

  ofs.open ("parse.op");
  WsdlParser wp (ifs, ofs);
  Soap sp;
  wp.addExtensibilityHandler (&sp);
  while (wp.getEventType () != WsdlParser::END)
    
    {
      switch (wp.getNextElement ())
        
        {
        case WsdlParser::DOCUMENTATION:
          cout << wp.getDocumentation () << endl;
          break;
        case WsdlParser::TYPES:
          cout << wp.getNumSchemas () << "   schema(s) found" << endl;
          break;
        case WsdlParser::MESSAGE:
          cout << "Message  :" << (wp.getMessage ())->getName () << endl;
          break;
        case WsdlParser::PORT_TYPE:
          const PortType * p = wp.getPortType ();
          cout << "Port Type :" << p->getName () << "  has  " << p-> 
            getNumOps () << " operations "<<endl;
          break;
        }
    }
  if (wp.m_ErrorOccured)
    return 1;
  return 0;
 }
 catch (WsdlException we)
   {
     cout<<"An Exception occurred ...@"<<we.line   
         <<":"<<we.col<<endl;
      cout<<we.description<<endl;
   
   }
 catch (SchemaParserException spe)
    {
     cout<<"An Exception occurred ...@"<<spe.line
         <<":"<<spe.col<<endl;

      cout<<spe.description<<endl;
    }
 catch (XmlPullParserException xpe)
    {
     cout<<"An Exception occurred ...@"<<xpe.line
	 <<":"<<xpe.col<<endl;

      cout<<xpe.description<<endl;
    }

 
}


