#include <iostream>
#include <fstream>
#include <string>
#include <xmlpull/XmlPullParser.h>
#include <xmlpull/XmlPullParserException.h>
#include <schemaparser/SchemaParser.h>
#include <schemaparser/SchemaParserException.h>
#include <wsdlparser/WsdlParser.h>
#include <wsdlparser/SoapExt.h>
#include <gsoap.h>
using namespace std;
int
main (int argc, char *argv[])
{
  ifstream ifs;
  ofstream gsoapHeader;
  if (argc <= 1)

    {
      cout << "Usage: wsdl2cpp <wsdl_file>  [<output_file_name>]" << endl;
      return 1;
    }

  else

    {



      ifs.open (argv[1]);
      if (ifs.fail ())

        {
          cout << "An Error occrred while opening ,file not found" <<
            argv[1] << endl;
          return 1;
        }
    }
  if (argc >= 3)
    gsoapHeader.open (argv[2]);

  else
    gsoapHeader.open ("gs.h");

  try {

  WsdlParser wp (ifs, cout);
  Soap sp;
  wp.addExtensibilityHandler (&sp);
  while (wp.getNextElement () != WsdlParser::END);
  if (wp.m_ErrorOccured)
    return 1;
  if (gsoap_generateHeaderFile (wp, sp, &gsoapHeader))

    {
      gsoapHeader.flush ();
      cout << "The gsoap header file has been stored in ";
      if (argc >= 3)
        cout << argv[2];

      else
        cout << "gs.h";
      cout << endl;
    }

  else
    cout << "An error occurred while generating gsoap header" << endl;
  return 0;
  }
  catch (WsdlException we)
   {
     cout<<"An Exception occurred ...@"<<we.line
                                       <<":"<<we.col<<endl;
      cout<<we.description<<endl;   
   }

  catch (SchemaParserException spe)
    {
      cout<<"An Exception occurred ..."<<endl;
      cout<<spe.description<<endl;
    }
  catch (XmlPullParserException xpe)
    {
      cout<<"An Exception occurred ..."<<endl;
      cout<<xpe.description<<endl;
    }
}
