/* 
 * wsdlpull - A C++ parser  for WSDL  (Web services description language)
 * Copyright (C) 2003 Vivek Krishna
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */
#ifndef _GSOAPH
#define _GSOAPH

#include <wsdlparser/WsdlParser.h>
#include <wsdlparser/SoapExt.h>

void gsoap_CopyFile2Stream (const char *file_name, ostream * os);

string xsd2CmapTable (int typeId);


//this function returns,or generates if necessary a unique prefix for each namespace
string gsoap_getNamespacePrefix (string ns);

bool gsoap_createDirective (const string & nsPrefix, const string & wsdlPart,
                       const string & param, const string & value,
                       ostream * os);

bool gsoap_isArray (ComplexType * ct);

string  gsoap_generateQualifiedType (int typeId, const SchemaParser* sParser);

void gsoap_generateParticleAndAttrs(ComplexType * cType,const SchemaParser * sParser,ostream * os);

bool gsoap_createStruct (const XSDType * pType, const SchemaParser* sParser, ostream * os,
                    string nsPrefix = "");

void gsoap_generate_HeaderStruct (int headerTypeId, const SchemaParser* sParser, ostream * os);

string gsoap_createRemoteMethod (string Ns, string methodName, ostream * os);

bool gsoap_addInParam (string typeName, string paramName, ostream * os);

bool gsoap_finishRemoteMethod (ostream * os);
bool gsoap_addOutParam (string typeName, string paramName, ostream * os);

/*
  This function generates the header file to be processed by the gsoap
  pre-processor
  return :true if the everything goes ok..else false
  */
bool gsoap_generateHeaderFile (WsdlParser & wParser, Soap & soap,
                               ostream * ofs);

#endif /*  */
