/* 
 * wsdlpull- A C++ parser  for WSDL  (Web services description language)
 * Copyright (C) 2003 Vivek Krishna
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

#include <utils.h>
#include <fstream>
#ifdef WITH_CURL
#include <curl/curl.h>
#endif
#include <stdio.h>

//All network related util functions

/*
 * Fetch a document at the given URI  and store it in a file
 */

bool fetchUri(string uri,string& filename)
{
  static int tmpFileNum=0;
  if(uri.find("http://")!=string::npos || 
     uri.find("ftp://") !=string::npos)
    {  
#ifdef WITH_CURL
      CURL * curl;
      CURLcode res;
      curl=curl_easy_init();
      FILE * file;
      filename='0'+tmpFileNum;
      filename+=".xsd";
      if(curl){
        file=fopen(filename.c_str(),"w");

        curl_easy_setopt(curl, CURLOPT_URL,uri.c_str());

        curl_easy_setopt(curl,CURLOPT_FILE,(void*)file);

        res = curl_easy_perform(curl);

        curl_easy_cleanup(curl);
        fclose(file);
        if(res)
          return false;
        else 
          return true;
      }
#endif
      return false;
    }else 
      { 
        /*
         * assume its a file on the disk
         */
        filename=uri;
        ofstream ofs;
        ofs.open(filename.c_str(),ios::in);
        if(ofs.fail()) {
          ofs.close();
          return false;
        }
        else {
          ofs.close();
          return true;
        }

      }
}



